Loading...
Searching...
No Matches
seqan3::aa20 Class Reference
Alphabet » Aminoacid

The canonical amino acid alphabet. More...

`#include <seqan3/alphabet/aminoacid/aa20.hpp>`

Inheritance diagram for seqan3::aa20:
[legend]

## Public Member Functions

Constructors, destructor and assignment
constexpr | aa20 () noexcept=default
| Defaulted.
constexpr | aa20 (aa20 const &) noexcept=default
| Defaulted.
constexpr | aa20 (aa20 &&) noexcept=default
| Defaulted.
constexpr aa20 & | operator= (aa20 const &) noexcept=default
| Defaulted.
constexpr aa20 & | operator= (aa20 &&) noexcept=default
| Defaulted.
| ~aa20 () noexcept=default
| Defaulted.
Public Member Functions inherited from seqan3::aminoacid_base< aa20, 20 >
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr | aminoacid_base (other_aa_type const other) noexcept
| Allow explicit construction from any other aminoacid type and convert via the character representation.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char_t >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Related Symbols

(Note that these are not member symbols.)
using | aa20_vector = std::vector<aa20>
| Alias for a std::vector of seqan3::aa20.
Literals
constexpr aa20 | operator""_aa20 (char const c) noexcept
| The seqan3::aa20 char literal.
constexpr aa20_vector | operator""_aa20 (char const *const s, size_t const n)
| The seqan3::aa20 string literal.

## Additional Inherited Members

Static Public Member Functions inherited from seqan3::aminoacid_base< aa20, 20 >
static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character value has a one-to-one mapping to an alphabet value.
Static Public Attributes inherited from seqan3::aminoacid_base< aa20, 20 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size = size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< derived_type, size, char_t >
using | char_type = std::conditional_t<std::same_as<char_t, void>, char, char_t>
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type = detail::min_viable_uint_t<size - 1>
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

The canonical amino acid alphabet.

The alphabet consists of letters A, C, D, E, F, G, H, I, K, L, M, N, P, Q, R, S, T, V, W, Y

The alphabet may be brace initialized from the static letter members (see above). Note that you cannot assign regular characters, but additional functions for this are available.

Note: Letters which belong in the extended alphabet will be automatically converted based on the frequency of their options.
Terminator characters are converted to W, because the most commonly occurring stop codon in higher eukaryotes is UGA2. Anything unknown is converted to S, because it occurs most frequently across 53 vertebrates1.

Input Letter | Converts to
--- | ---
B | D1
J | L1
O | L1
U | C1
Z | E1
X (Unknown) | S1
* (Terminator) | W2

1King, J. L., & Jukes, T. H. (1969). Non-Darwinian Evolution. Science, 164(3881), 788-798. doi:10.1126/science.164.3881.788
2Trotta, E. (2016). Selective forces and mutational biases drive stop codon usage in the human genome: a comparison with sense codon usage. BMC Genomics, 17, 366. https://doi.org/10.1186/s12864-016-2692-4

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/aminoacid/aa20.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::aa20 letter{'A'_aa20};
letter.assign_char('C');
seqan3::debug_stream << letter << '\n'; // prints "C"
letter.assign_char('?'); // Unknown characters are implicitly converted to S.
seqan3::debug_stream << letter << '\n'; // prints "S"
}
aa20.hpp
Provides seqan3::aa20, container aliases and string literals.
seqan3::aa20
The canonical amino acid alphabet.
Definition aa20.hpp:61
seqan3::alphabet_base::assign_char
constexpr derived_type & assign_char(char_type const chr) noexcept
Assign from a character, implicitly converts invalid characters.
Definition alphabet_base.hpp:160
debug_stream.hpp
Provides seqan3::debug_stream and related types.
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.

This entity is stable. Since version 3.1.

## Friends And Related Symbol Documentation

## aa20_vector

using aa20_vector = std::vector<aa20>

related

Alias for a std::vector of seqan3::aa20.

This entity is stable. Since version 3.1.

## operator""_aa20() [1/2]

aa20_vector operator""_aa20 | ( | char const *const | s,
|  | size_t const | n )

related

The seqan3::aa20 string literal.

Parameters

  [in] | s | A pointer to the character string to assign.
  [in] | n | The size of the character string to assign.

Returns
  seqan3::aa20_vector

You can use this string literal to easily assign to aa20_vector:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/aminoacid/aa20.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::aa20_vector sequence1{"ACGTTA"_aa20};
seqan3::aa20_vector sequence2 = "ACGTTA"_aa20;
auto sequence3 = "ACGTTA"_aa20;
}

This entity is stable. Since version 3.1.

## operator""_aa20() [2/2]

aa20 operator""_aa20 | ( | char const | c | ) |

related

The seqan3::aa20 char literal.

Parameters

  [in] | c | The character to assign.

Returns
  seqan3::aa20

You can use this char literal to assign a seqan3::aa20 character:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/aminoacid/aa20.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::aa20 letter1{'A'_aa20};
auto letter2 = 'A'_aa20;
}

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- aa20.hpp

Hide me